//
// BEAN'S DYNAMITE DERBY - GAMEPLAY
// Featuring a lot of crying and suffering from FrivolousAqua
//

-- mm yeah
local DBU_FuckerIsValid = DBU_FuckerIsValid

// BDD_Reset()
// because the mapload function was getting out of hand
local function BDD_Reset()
	// Old toggles, number of players
	bdd.oldjackpot = bdd.jackpotvalue.value
	bdd.oldovertime = bdd.overtimetoggle.value
	bdd.oldscaletoggle = bdd.scaledtimetoggle.value
	bdd.olddetonationtime = bdd.detonationtime.value
	bdd.numplayers = 0
	bdd.numplayersremaining = 0
	
	// Timers
	bdd.timer = 10
	bdd.breaktime = false
	bdd.overtime = false
	bdd.overtimer = bdd.overtimelimit.value * TICRATE
	bdd.lastpassed = 0 // So overtime does not trigger during the starting sequence
	bdd.oldlastpassed = bdd.lastpassedlimit.value * TICRATE
	bdd.bonustimer = 0
	
	// Death messages
	bdd.didsomeoneragequit = false
	bdd.didsomeoneleave = false
	bdd.lastdied = ""
	bdd.deathmessagetimer = 0
	
	// Winning
	bdd.gameover = false
	bdd.gameoverresults = false
	bdd.gameovertime = 0 -- welcome back old friend
	
	// Misc.
	bdd.warningspeedup = 1
	bdd.doilus = -1
	bdd.oldringscale = bdd.scaledringtoggle.value
	
	// How many players are present.
	// ...That, and we need to reset some player variables.
	for player in players.iterate do
		player.youshouldnotspectate = false
		-- If you are not a spectator, then you're considered in the game
		if DBU_FuckerIsValid(player) then
			bdd.numplayers = bdd.numplayers + 1
			player.youshouldnotspectate = true
		end
		player.bddouttimer = 0 -- For the OUT!!! graphics
		player.bddringpayout = 0 -- For the ring payout graphic
		player.bonustime = false
		-- If scaled time is off, then a custom duel mode time is used
		if not bdd.oldscaletoggle then
			player.bdddueltime = bdd.olddetonationtime * TICRATE
		else
			player.bdddueltime = 60 * TICRATE
		end
		player.indanger = false
		player.dangertimer = 0 // For the danger sound
		player.bddLastPosition = 0
		player.bddTallyRank = 0
		player.bddDisplayTime = 0
		player.bddDisplayStat = 0
		player.bddDeathTime = 0
		player.bddduelpartner = nil
	end
	
	-- Second iteration to find your duel mode partner...
	for player in players.iterate do
		if not DBU_FuckerIsValid(player) then continue end
		-- Find your duel mode partner
		if bdd.numplayers == 2 then
			for q in players.iterate do
				if not DBU_FuckerIsValid(q) then continue end
				if q == player then continue end
				player.bddduelpartner = q
			end
		end
		--print(string.format("%s's duel partner is %s!", player.name, player.bddduelpartner.name))
	end
	
	bdd.tally.active = false
	
	-- If there's specifically two players, then turn on duel mode
	if bdd.numplayers == 2 then
		bdd.duelmode = true
	-- dimbass
	else
		bdd.duelmode = false
	end
end

// BDD_ActivateBreak(p)
// Convenient function to call to reduce redundancy; controls a handful of variables
// p - Player
local function BDD_ActivateBreak(p)
	bdd.numplayersremaining = bdd.numplayersremaining - 1
	bdd.lastdied = p.name
	bdd.deathmessagetimer = 5 * TICRATE
	bdd.doilus = P_RandomRange(1, 100) -- You've heard of the bonus stage, but have you heard of the legendary DOILUS stage?
	
	-- kind of a brute force solution for the hud
	for player in players.iterate
		if not DBU_FuckerIsValid(player) then continue end
		player.bddringpayout = 0
		if bdd.debuglogger.value then
			CONS_Printf(player, "\139BDD DEBUG:\128 ROUND OVER! Evaluating player's conditions for receiving rings...")
			CONS_Printf(player, "\139BDD DEBUG:\128 Are you NOT in spectator? " .. tostring(not player.spectator))
			CONS_Printf(player, "\139BDD DEBUG:\128 Are you in a worse position (not in first)? " .. tostring(player.position > 1))
			CONS_Printf(player, "\139BDD DEBUG:\128 Are you NOT eliminated? " .. tostring(not (player.pflags & PF_ELIMINATED)))
			CONS_Printf(player, "\139BDD DEBUG:\128 Is old ring scale on? " .. tostring(bdd.oldringscale))
			CONS_Printf(player, "\139BDD DEBUG:\128 Are the number of players remaining not 0? " .. tostring(bdd.numplayersremaining != 0))
		end
		if not player.spectator and player.position > 1 and not (player.pflags & PF_ELIMINATED) then
			if bdd.oldringscale and bdd.numplayersremaining != 0 then
				player.bddringpayout = min(((bdd.oldjackpot * player.position) / bdd.numplayersremaining), bdd.oldjackpot)
			else
				player.bddringpayout = bdd.oldjackpot
			end
		end
	end
	
	bdd.breaktimer = bdd.grace + bdd.refilltics
	bdd.award = true
	bdd.breaktime = true
	bdd.overtimer = bdd.overtimelimit.value * TICRATE
	bdd.overtime = false -- Make sure to turn off overtime if someone goes down
end

// BDD_BonusTime(p)
// Duel mode exclusive. Rewards bonus time if the player regains their position after some time.
// p - Player
local function BDD_BonusTime(p)
	S_StartSound(nil, sfx_elim10, p)
	p.bdddueltime = p.bdddueltime + (TICRATE * 5)
	bdd.lastdied = p.name -- Bit of a hack? Store the player here instead of using a new variable
	bdd.bonustimer = TICRATE
end

// BDD_Explode(p)
// Dedicated function to exploding a player.
// p - Player
local function BDD_Explode(p)
	S_StartSound(nil, sfx_elim01)
	// You got the crowd excited now!
	if bdd.overtimer == 0 then
		S_StartSound(nil, sfx_elim07)
	end
		
	-- Only play the character's loss sound if the user's okay with it.
	-- It will also only play if there's more than two players remaining.
	if bdd.userchardeath.value == 1 and bdd.numplayersremaining > 2 then
		S_StartSound(nil, skins[p.skin].soundsid[SKSKLOSE])
	end
	
	-- Reset some of these variables
	p.growshrinktimer = 0 -- Otherwise, the music would continue
	p.invincibilitytimer = 0 -- Otherwise, the music would continue
	p.invincibilityextensions = 0
	
	-- Reset this, or else your controller's stuck rumbling for a century
	p.sneakertimer = 0
	p.mo.hitlag = 0
		
	-- Explode
	p.mo.flags = $ | MF_SHOOTABLE -- Make it so that the player ALWAYS gets shot
	p.speed = 0 -- If the player's speed is 0, they shouldn't tether
	P_DamageMobj(p.mo, nil, nil, 1, DMG_TIMEOVER)
	p.indanger = false
	p.pflags = $1 | PF_NOCONTEST | PF_ELIMINATED -- Make sure to ALWAYS give them PF_ELIMINATED
	p.bddDeathTime = p.realtime -- Save this...
		
	BDD_ActivateBreak(p)
	-- Say KO to the player who went out!
	if bdd.numplayersremaining != 1 then S_StartSound(nil, sfx_elima5, p) end
	bdd.funnyvalue = P_RandomRange(1, #bdd.wittymessages) // Roll it
end

// BDD_BombTime()
// If a player joins or leaves, then it's important to recalculate this to make it
// more accurate and such.
local function BDD_BombTime()
	-- Keeping this here for legacy reasons; it'd get overwritten regardless
	-- - Aqua
	if bdd.numplayersremaining < 4 then bdd.timer = 60 // Duel mode (and also that guy)
	elseif bdd.numplayersremaining < 9 then bdd.timer = 25 // Average lobby
	elseif bdd.numplayersremaining < 13 then bdd.timer = 20 // Big lobby
	else bdd.timer = 15 end // Huge lobby...
	
	-- Make sure this doesn't run in duel mode (I don't believe it gets called in duel mode,
	-- but it's better to be safe than sorry)
	-- Also only run this if the # of people is greater than 2
	-- TODO
	/*
	if not bdd.duelmode and bdd.numplayersremaining > 2 then
		local lobbytime = 60 / (1 + bdd.numplayersremaining)
		bdd.timer = max(, 10)
	end
	*/
	
	-- However, if the host doesn't want time to scale, then...
	if not bdd.oldscaletoggle then
		bdd.timer = bdd.olddetonationtime
	end
	
	// Recalc this
	bdd.refilltics = (bdd.timer * TICRATE) / 7
end

// SPAWN SIGNPOST
// Borrowed from Character Utilities Returns, credits go to JugadorXEI for originally
// writing this function
local function P_SetupSignObject(sign, pmo, signType)
    local cur = sign
    local prev = nil

    -- Setup the sign itself
    sign.scale = 5 * sign.scale / 2 -- 2.5x
    sign.destscale = sign.scale
    sign.target = pmo
    sign.state = S_SIGN_POLE

    sign.movefactor = sign.z
    sign.z = $ + (576*sign.scale) * P_MobjFlip(sign)
    sign.old_z = sign.z -- interp hijack
    sign.movecount = 1
    sign.extravalue1 = AngleFixed(sign.angle) >> FRACBITS

    -- Setup the overlay pieces
    -- Front
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_FACE
    cur.hnext.extravalue1 = 6
    cur.hnext.extravalue2 = 0

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    -- Player icon
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.skin = pmo.skin
    if signType == 4 then
        cur.hnext.state = S_SIGN_ERROR
    else 
        cur.hnext.state = S_KART_SIGN
    end
    
    cur.hnext.extravalue1 = 7
    cur.hnext.extravalue2 = 0

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    -- Back
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_BACK
    cur.hnext.extravalue1 = 6
    cur.hnext.extravalue2 = 2

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    -- Sides
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_SIDE
    cur.hnext.extravalue1 = 30
    cur.hnext.extravalue2 = 1

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_SIDE
    cur.hnext.extravalue1 = 30
    cur.hnext.extravalue2 = 3

    prev = cur
    cur = cur.hnext
    cur.hprev = prev
end

// GAME INITIALIZATION
// We have to calculate how much time is spent in position before the race actually begins.
// There's a fair bit of initialization here too with resetting variables and such!
addHook("MapLoad", function ()
	BDD_Reset() // Reset the game quickly

	-- Dynamite Derby only runs if...
	-- - It's in the correct gametype
	-- - If there's more than one player
	-- - In any map other than Test Run (TypeOfLevel = 0)
	if (gametype == GT_BDD) and (bdd.numplayers > 1) and (mapheaderinfo[gamemap].typeoflevel != 0) then
		-- As of right now, section races are incompatible. (At least sectioned circuits are.)
		-- Check for that.
		if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE then
			-- Add warnings to clarify that the gametype does not work with these two
			print("\133ERROR:\128 Section races aren't supported in Dynamite Derby! Skipping...")
			G_ExitLevel()
			return
		end
		
		bdd.starting = true -- We're starting, aren't we? ...Right?
		bdd.currealpregame = bdd.pregametime.value
		bdd.gametimer = bdd.pregametime.value * TICRATE
		bdd.numplayersremaining = bdd.numplayers
		
		BDD_BombTime() -- For setting up the timer!
	// literally just here for waiting text
	else
		for p in players.iterate
			if (p.mo and p.mo.valid) then
				bdd.lastdied = p.name
			end
		end
	end
	
	if (gametype == GT_BDD) and (mapheaderinfo[gamemap].typeoflevel == 0) then
		print("\131NOTICE:\128 Level's TypeOfLevel is 0. Treating the level as a lobby...")
	end
end)

-- LEVELTIME == 1 checks
-- moved from the timer thinker
local function BDD_LevelStart()
	// Set numlaps PROPERLY
	if leveltime == 1 then
		CV_StealthSet(CV_FindVar("cheats"), 1) -- I'm feeling quite sneaky... (Thanks Juggy)
		if (gametype == GT_BDD) and (bdd.numplayers > 1) and (mapheaderinfo[gamemap].typeoflevel != 0) then
			-- Circuit section map support
			if mapheaderinfo[gamemap].lapspersection > 1 then
				-- If there's more than one lap per section,
				if mapheaderinfo[gamemap].numlaps * 5 > 99 then
					-- Map's loops are really big for no reason.
					-- Just don't bother at this rate.
					CV_Set(CV_FindVar("numlaps"), "Map Default")
				else
					-- Set it to the lap count multiplied with the laps per section AND by 5.
					-- Results in a pretty safe number (i.e. Death Egg on 60 laps).
					CV_Set(CV_FindVar("numlaps"), mapheaderinfo[gamemap].numlaps * 5)
				end
			else
				-- Otherwise...
				if mapheaderinfo[gamemap].numlaps * 10 > 99 then
					-- Your map's lap count is obscenely big.
					-- Just set it to the maximum lap count instead.
					-- (Looking at you, Roundabout.)
					CV_Set(CV_FindVar("numlaps"), 99)
				else
					-- Set it to the lap count multiplied with 10.
					CV_Set(CV_FindVar("numlaps"), mapheaderinfo[gamemap].numlaps * 10)
				end
			end
		else
			// The number of laps has to be manually reset. So, let's do it!
			CV_Set(CV_FindVar("numlaps"), "Map Default")
		end
		CV_StealthSet(CV_FindVar("cheats"), 0) -- Turn it back off silently so no one else can abuse it!
		
		-- Set waiting for players message
		bdd.waitvalue = P_RandomRange(1, #bdd.waitmessages)
	end
end

// TIMERS
// Moved from derbyHud.lua, this variable is now used extensively through this mode
local function BDD_Timers()
	if bdd.gameover == true then return end // Don't run this code if we're done with the game
	// Only runs if it's BDD
	if gametype ~= GT_BDD then return end
	
	if bdd.deathmessagetimer == 0 then
		bdd.didsomeoneragequit = false
		bdd.didsomeoneleave = false
	end
	
	-- HAYA: PSA: move any fucking timer to a proper thinker, not the HUD
	bdd.deathmessagetimer = max(0, $-1)
	bdd.bonustimer = max(0, $-1)
	
	-- GET OUT
	for p in players.iterate
		-- HM.
		if not DBU_FuckerIsValid(p) then continue end
	
		-- p.bddouttimer = p.bddouttimer and $ or 0
		if bdd.deathmessagetimer > 0 then
			if not (p.pflags & PF_ELIMINATED) then continue end
			
			p.bddouttimer = min($ + 1, TICRATE * 3)
		end
	end

	-- Decrement the timer.
	-- The gametimer goes down if...
	-- - Level time is greater than the start time
	-- - Break time is inactive
	-- - Overtime is not going
	if (leveltime > starttime) and bdd.breaktime == false and bdd.overtime == false then
		-- Used for both the pregame and the main timer
		-- This only runs in duel mode if the mode is still starting (for pregame)
		if not bdd.duelmode or bdd.starting then
			bdd.gametimer = bdd.gametimer - 1
		-- Duel mode code
		else
			-- Iterate through all players and see if their placement is greater than 1
			-- If so, lower their timer
			for p in players.iterate
				if not DBU_FuckerIsValid(p) then continue end
				// CONS_Printf(p, "Your duel time left: " .. tostring(p.bdddueltime))
				--p.bdddueltime = p.bdddueltime and $ or 0 -- crying
				if p.position > 1 and p.bdddueltime then
					p.bdddueltime = p.bdddueltime - 1
				end
			end
		end
		-- Code for Fav's speed-up
		if bdd.gametimer < 10 * TICRATE and leveltime % 13 == 0 then bdd.warningspeedup = $+1 end 
	elseif bdd.breaktime == true then
		-- Keep the timer at 0 for some dramatic effect.
		if bdd.breaktimer > ((bdd.grace / 2) + bdd.refilltics) then
			bdd.gametimer = 0
		-- Start refilling!
		elseif bdd.breaktimer > (bdd.grace / 2) then
			-- FINAL!
			if bdd.numplayersremaining == 2 and not bdd.duelmode and bdd.breaktimer == (bdd.grace / 2) + 1 then
				S_StartSound(nil, sfx_elima4)
			end
			S_StartSound(nil, sfx_ptally)
			bdd.gametimer = bdd.gametimer + 7
			bdd.warningspeedup = 1
		end
		
		bdd.breaktimer = bdd.breaktimer - 1
	end
	
	-- Only decrement this while we're in overtime!
	if bdd.overtime == true then
		bdd.gametimer = 0
		bdd.overtimer = bdd.overtimer - 1
		-- Be sure to make sure we aren't in overtime now if we hit 0
		if bdd.overtimer == 0 then
			bdd.overtime = false
		end
	end
	
	-- No need to increment the value while we're still starting. ...Or, if we're in break time.
	if bdd.starting == false and bdd.breaktime == false then
		bdd.lastpassed = bdd.lastpassed + 1
	end
end

// GAMEPLAY
// PRETTY MUCH THE BIG BULK OF THIS
local function BDD_Gameplay()
	if bdd.gameover == true then return end // Don't run this code if we're done with the game
	// Only runs if it's BDD and it's more than one player.
	if gametype ~= GT_BDD then return end
	if bdd.numplayers <= 1 then return end
	if (mapheaderinfo[gamemap].typeoflevel == 0) then return end

	-- Please let this work...
	-- - Aqua
	racecountdown = 0
		
	-- Give a warning about the pre-game being at the halfway mark.
	if (bdd.gametimer == ((bdd.currealpregame * TICRATE) / 2)) 
	and bdd.starting then
		S_StartSound(nil, sfx_elim03)
	end
		
	-- This still could probably be better. :/
	-- Make sure this doesn't play during break time too
	if (bdd.gametimer == 3 * TICRATE or
	bdd.gametimer == 2 * TICRATE or
	bdd.gametimer == TICRATE) and 
	bdd.breaktime == false then S_StartSound(nil, sfx_s3ka7) end
		
	-- A BRAWL IS SURELY BREWING! BEGIN!
	if (bdd.gametimer == 0)
	and bdd.starting then
		-- We're starting! Ring the bell!
		S_StartSound(nil, sfx_kc4b)
		bdd.starting = false
		bdd.breaktime = true
		bdd.award = false
		bdd.breaktimer = bdd.grace + bdd.refilltics
			
		-- We need to loop through each player to see if they're spectating or not.
		-- If they're in the race, then they cannot safely spectate.
		-- Don't go forfeiting now!
		for player in players.iterate
			if DBU_FuckerIsValid(player) then
				player.youshouldnotspectate = true
			end
		end
	end
		
	-- Now the fun begins!
	-- We need to start exploding the players that aren't doing so great.
	if bdd.starting == false then
		if bdd.breaktimer == 0 then bdd.breaktime = false end
		
		-- END IT ALL, DON'T EXPLODE ANYONE ELSE
		if bdd.numplayersremaining == 1 then bdd.gameover = true end
		
		-- Activate overtime if positions are changing last minute!
		if bdd.gametimer == 0 and bdd.overtime == false
		and bdd.lastpassed <= bdd.oldlastpassed and bdd.overtimer > 0
		and bdd.breaktime == false 
		and bdd.oldovertime then -- Add a check here if the host wants overtime
			S_StartSound(nil, sfx_kc47)
			bdd.overtime = true
		end
		
		-- You must die!
		-- Duel mode specific
		if bdd.duelmode then
			-- Blow up the person in last place if their timer hits 0
			for p in players.iterate do
				-- HM.
				if not DBU_FuckerIsValid(p) then continue end
				if p.pflags & PF_ELIMINATED then continue end
				if p.bdddueltime <= 0 and not (p.pflags & PF_ELIMINATED) then
					BDD_Explode(p)
					break
				end
			end
		-- Normal gameplay
		else
			if bdd.gametimer <= 0 and bdd.breaktime == false and bdd.overtime == false and bdd.gameover == false then
				// KILL
				// ...Well, not just yet
				// We have to iterate through the players first to find each
				local worstplace = 0;
				for p in players.iterate do
					if not DBU_FuckerIsValid(p) then continue end -- Skip if they're not valid (dedis)
					if p.pflags & PF_ELIMINATED then continue end -- Skip if they're already out (lost colony...)
					if p.position >= bdd.numplayersremaining then
						BDD_Explode(p)
						// Don't iterate through the rest of the players
						break
					end
					
					-- Track the worst place possible.
					-- This is to keep track of ties.
					if worstplace < p.position then
						worstplace = p.position
					end
				end
				
				-- By this point, bdd.breaktime should have been set to true.
				-- This means there's a tie...
				-- So, RESOLVE IT WITH VIOLENCE!
				if bdd.breaktime == false then
					for p in players.iterate do
						if not DBU_FuckerIsValid(p) then continue end -- Skip if they're not valid (dedis)
						if p.pflags & PF_ELIMINATED then continue end -- Skip if they're already out (lost colony...)
						if p.position >= worstplace and not (p.pflags & PF_ELIMINATED) then
							BDD_Explode(p)
							// Don't iterate through the rest of the players
							break
						end
					end
				end
				bdd.gametimer = 0
			end
		end
			
		// AWARDING RINGS
		// A catchup mechanic added to keep things interesting! Gotta keep up
		// with the pack somehow! Award rings based on placement!
		// just make sure not to divide by zero
		if bdd.breaktimer == ((bdd.grace / 2) + bdd.refilltics)
		and bdd.award == true
		and bdd.ringtoggle.value == 1 then
			for p in players.iterate do
				if not DBU_FuckerIsValid(p) then continue end
				// make sure they actually exist
				if not p.spectator and p.position > 1 and not (p.pflags & PF_ELIMINATED) then
					if bdd.debuglogger.value then
						CONS_Printf(p, "\139BDD DEBUG:\128 Awarding " + p.bddringpayout + " rings!")
					end
					p.superring = p.superring + p.bddringpayout
				end
			end
			
			bdd.award = false
		end
	end
end

// ENDING THE GAME
// There's some pretty hacky stuff in here about changing the game music.
local function BDD_GameEnd()
	if bdd.gameover == false then return end // Don't run this code if we AREN'T done with the game
	if not gametype == GT_BDD then return end // Don't run this code if we aren't in BDD
	
	-- Only triggers once during the start of the game over sequence.
	-- Iterates through all players and scores them appropriately, along with removing the
	-- NOCONTEST and ELIMINATED flags for the intermission screen.
	-- Also plays nicely with some HUD elements like the OUT!!! graphics.
	if bdd.gameoverresults == false then
		local perfect = false
		for p in players.iterate
			-- Dedicated servers....
			if not DBU_FuckerIsValid(p) then continue end
			-- Don't spawn a signpost for a player that doesn't exist...
			-- Nor score a player that doesn't exist, either!
			if (p.mo and p.mo.valid) then
				if not (p.pflags & PF_ELIMINATED) then
					local sign = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.floorz, MT_SIGN)
					sign.angle = p.mo.angle + ANGLE_180
					sign.cvmem = 2
					P_SetupSignObject(sign, p.mo, 2)
				end
			
				p.roundscore = bdd.numplayers - p.position
				if not p.bot or not netgame then p.pflags = $1 & ~(PF_NOCONTEST|PF_ELIMINATED) end
				if not bdd.oldscaletoggle then
					if p.bdddueltime == bdd.olddetonationtime then perfect = true end
				else
					if p.bdddueltime == TICRATE * 60 then perfect = true end
				end
				
				-- Dumb hack: just set the view back to the player for their results
				-- is this even a hack? or
				if not replayplayback then
					COM_BufInsertText(p, "view " .. tostring(#p))
				end
				if p.position == 1 then
					p.bddDeathTime = p.realtime
				end
			end
			p.bddLastPosition = p.position
			p.exiting = 1 -- P_DoPlayerExit? pssssh
			p.position = p.bddLastPosition
			-- fake the end camera
			p.awayviewmobj = P_SpawnMobj(0, 0, 0, MT_HORNCODE) -- MT_HORNCODE is not netsynched hehe
			if bdd.playerCam then
				P_SetOrigin(p.awayviewmobj, bdd.playerCam.x, bdd.playerCam.y, bdd.playerCam.z)
				p.awayviewmobj.angle = bdd.playerCam.angle
				p.awayviewmobj.pitch = bdd.playerCam.aiming
				p.awayviewmobj.state = S_INVISIBLE
			end
			p.awayviewtics = INT32_MAX
			p.nocontrol = INT32_MAX -- prevent control of any kind
			if not p.bot or not netgame then p.pflags = $1 & ~(PF_NOCONTEST|PF_ELIMINATED) end -- HUH???
			racecountdown = 0
			// print("But when applying p.exiting, " + p.name + " ranked in " + p.position)
		end
		
		-- 2.4 / HEP3 exclusive.
		-- Trying to work with P_DoPlayerExit is a fucking pain
		-- no more
		if Music_Play then Music_Play("finish_silence") end
		
		if perfect and bdd.duelmode then
			S_StartSound(nil, sfx_elima2) -- PERFECT!!
		else
			S_StartSound(nil, sfx_elima1) -- WINNAR!!!1
		end
		exitcountdown = TICRATE*10
		
		BDD_TallyInit(bdd.tally)
	end
	
	BDD_TallyTick(bdd.tally)
	
	-- Fun timing stuff
	if bdd.gameovertime == TICRATE then
		S_StartSound(nil, sfx_elim09)
	elseif bdd.gameovertime == TICRATE + (TICRATE / 2) then
		-- Character win sound
		-- Iterate through the players and play a sound for the player in first.
		for p in players.iterate
			if p.spectator then continue end
			if bdd.userchardeath.value == 1 and p.position == 1 then
				S_StartSound(nil, skins[p.skin].soundsid[SKSKWIN])
			end
		end
	end

	-- Thanks to Haya, we now have a way to incorporate the music we wanted to use.
	-- Just, without any of the weird issues we had before with the music player.
	-- While this still requires HEP3 as of now, this will not run if the function doesn't exist!
	-- It's perfect!
	-- - Aqua
	if Music_Play then
		if bdd.gameovertime == TICRATE*3 then
			-- Sometimes this isn't valid...
			if consoleplayer and consoleplayer.valid then
				-- TODO, use party position instead
				if consoleplayer.position <= (bdd.numplayers/2) then
					Music_Remap("bddintermission", "ELIMWI")
				else
					Music_Remap("bddintermission", "ELIMLS")
				end
				Music_Play("bddintermission")
			end
		end
	end
	
	-- Do this a bit late to allow p.exiting to work
	if bdd.gameovertime > TICRATE*10+1 then
		G_ExitLevel()
	end
	
	-- Should also decrement it here...
	bdd.deathmessagetimer = max(0, $-1)
	
	bdd.gameoverresults = true
	bdd.gameovertime = $ + 1
end

// One for all, all for one
addHook("ThinkFrame", function ()
	BDD_LevelStart()
	BDD_Timers()
	BDD_Gameplay()
	BDD_GameEnd()
end)

-- Handle ending specific things....
addHook("PreThinkFrame", function()
	if not gametype == GT_BDD then return end // Don't run this code if we aren't in BDD
	if not bdd.gameover then return end -- Game is NOT over, ignore
	
	for p in players.iterate do
		if not DBU_FuckerIsValid(p) then continue end
		-- run that back
		-- prevent the tally from showing up i think
		if p.exiting and bdd.gameovertime < TICRATE*10 then
			p.exiting = 0
			if not p.bot or not netgame then p.pflags = $ & ~PF_NOCONTEST end
		end
		
		-- Prevent the results just showing up as RETIRED
		-- prematurely end the level here, too
		if exitcountdown == 2 then 
			-- no one gets left behind. except spectators
			p.exiting = 1
		end
	end
end)

// DEATH ANNOUNCEMENTS
// This hook is dedicated entirely to just announcing people dying
// ok thats not true there's some other stuff
addHook("PlayerThink", function (p)
	if not gametype == GT_BDD then return end // Don't run this code if we aren't in BDD
	
	-- Uh
	if bdd.gameover == true and DBU_FuckerIsValid(p) then
		p.position = p.bddLastPosition
		p.positiondelay = 0
		-- Never under any circumstance be NO CONTEST'd.
		if not p.bot or not netgame then p.pflags = $ & ~PF_NOCONTEST end
		return 
	end // Don't run this code if we're done with the game

	// only run if you're in elim stupid
	if (gametype == GT_BDD) and (bdd.numplayers > 1) and (mapheaderinfo[gamemap].typeoflevel != 0) then
		// If the player is eliminated but *not* in spectator yet, then announce they
		// have been eliminated!
		if p.deadtimer == 2 * TICRATE and (p.pflags & PF_ELIMINATED) and DBU_FuckerIsValid(p) then
			p.youshouldnotspectate = false
			-- Hide and make the player not think anymore !!
			-- otherwise you will go to 3 fps on azure axiom
			p.mo.flags = $ | MF_NOTHINK
			p.mo.renderflags = $ | RF_DONTDRAW
			local bestplayer = ""
			-- Iterate through the players to find the best performing one
			for player in players.iterate
				-- if isdedicatedserver and player == server then continue end
				bestplayer = player.name
				if player.position == 1 then break end -- the literal best position
			end
			-- Force the player to spectate the best performing player
			-- This is necessary as you do not automatically get put into spectate in this state.
			if bdd.debuglogger.value then
				CONS_Printf(p, "\139BDD DEBUG:\128 Attempting to view " .. "\"" .. bestplayer .. "\"" .. ".")
			end
			COM_BufInsertText(p, "view " .. "\"" .. bestplayer .. "\"")
		end
		
		// Handle people joining midgame.
		if not p.spectator
		and bdd.starting 
		and not p.youshouldnotspectate then
			bdd.numplayers = bdd.numplayers + 1
			bdd.numplayersremaining = bdd.numplayersremaining + 1
			p.dangertimer = 0
			p.bddouttimer = 0
			p.indanger = false
			p.youshouldnotspectate = true
			BDD_BombTime()
		end
		
		// Alternatively, if a player spectates before being eliminated, then say
		// that they forfeited.
		if not (p.pflags & PF_ELIMINATED) // Are you not eliminated?
		and p.spectator // Did you start spectating?
		and p.youshouldnotspectate then // Are you not able to safely spectate? (Did the elim begin?)
			// Sometimes people have things to do and that's okay.
			// (Changing characters also usually throws you out of the game, so that's also
			// something to take note of.)
			if bdd.starting then
				bdd.numplayersremaining = bdd.numplayersremaining - 1
				p.youshouldnotspectate = false
				BDD_BombTime()
			// ...If you are quitting during the game, then
			else
				S_StartSound(nil, sfx_elim01)
				// Boooooo.
				S_StartSound(nil, sfx_elim08)
				
				// ...Well, they *technically* got eliminated, right?
				bdd.didsomeoneragequit = true
				bdd.funnyvalue = P_RandomRange(1, #bdd.forfeitmessages) // Roll it
				BDD_ActivateBreak(p)
				
				p.youshouldnotspectate = false
				p.indanger = false
			end
		end
		
		-- hehe. im in danger
		if p.position == bdd.numplayersremaining and not p.indanger and not bdd.starting and not bdd.breaktime then
			S_StartSound(nil, sfx_elim03, p)
			p.indanger = true
			bdd.lastpassed = 0
		end
		
		// Danger mechanics!
		// This status goes away if you get into a better placement.
		// You'll be hearing a familiar sound from Colors DS the longer you stay in...
		if p.indanger and DBU_FuckerIsValid(p) then
			if bdd.duelmode and p.bonustime == false and bdd.lastpassed >= (10 * TICRATE) then
				bdd.doilus = P_RandomRange(1, 100) -- You've heard of the bonus stage, but have you heard of the legendary DOILUS stage?
				p.bonustime = true
			end
		
			// You get to survive... For now
			// The breaktime check will make sure that if someone leaves midgame,
			// the flag is cleared properly from the player.
			if p.position < bdd.numplayersremaining or bdd.breaktime then
				p.indanger = false
				p.dangertimer = 0 // reset the timer so that it's always consistent
				if p.bonustime and bdd.duelmode then 
					BDD_BonusTime(p)
					p.bonustime = false
				end
				return
			end
		
			p.dangertimer = p.dangertimer and $ or 0
			p.dangertimer = p.dangertimer + 1 // increment this every tic
			// If two seconds have passed, reset the timer and play the sound
			if p.dangertimer == 70 then
				S_StartSound(nil, sfx_elim02, p)
				p.dangertimer = 0
			end
		end
	end
end)

// INTERMISSION SCREEN
// Just to reset the music back to normal.
addHook("IntermissionThinker", function()
	if not gametype == GT_BDD then return end // Don't run this code if we aren't in BDD
	if bdd.gameover == false then return end
	bdd.gameover = false
end)

// LEAVING SO SOON?
addHook("PlayerQuit", function(p)
	if not gametype == GT_BDD then return end // Don't run this code if we aren't in BDD
	if p.spectator then return end // Don't run this code if the person who left was spectating
	if (p.pflags & PF_ELIMINATED) then return end // Don't run this code if the person fucking blew up
	
	if not bdd.starting then
		bdd.didsomeoneleave = true
		BDD_ActivateBreak(p)
	else
		-- Decrease the count here, as BDD_BombTime doesn't
		bdd.numplayersremaining = $ - 1
		BDD_BombTime()
	end
end)

-- Annoyingly, the player dies
-- So uhh prevent that
addHook("ShouldDamage", function(pmo)
	if not gametype == GT_BDD then return end // Don't run this code if we aren't in BDD
	if bdd.gameover == false then return end
	if pmo.player.position != 1 then return end
	return false
end, MT_PLAYER)

// Test command // view statistics
COM_AddCommand("bddstats", function(p)
	if p and p.valid and p.mo and p.mo.valid then
		CONS_Printf(p, "\139BDD DEBUG:\128 You are eliminated: " + p.pflags & PF_ELIMINATED)
		CONS_Printf(p, "\139BDD DEBUG:\128 You should not spectate: " + p.youshouldnotspectate)
		CONS_Printf(p, "\139BDD DEBUG:\128 Pre-game time: " + bdd.pregametime.value)
		CONS_Printf(p, "\139BDD DEBUG:\128 Current pre-game time for race: " + bdd.currealpregame)
		CONS_Printf(p, "\139BDD DEBUG:\128 Game time: " + leveltime)
		CONS_Printf(p, "\139BDD DEBUG:\128 Kaboom time: " + bdd.kaboomtime)
		CONS_Printf(p, "\139BDD DEBUG:\128 Award time: " + bdd.awardtime)
	end
end)
