//
// BEAN'S DYNAMITE DERBY - INITIALIZATION
//

// Define the gametype here
G_AddGametype({
	name = "Dynamite Derby",
	identifier = "BDD",
	rules = GTR_CIRCUIT|GTR_BOTS|GTR_ENCORE,
	typeoflevel = TOL_RACE,
	intermissiontype = int_score,
	gppic = "BDDICON",
	gppicmini = "BDDICON",
	replaypic = "BDDICON"
})

rawset(_G, "bdd", {})

// Freeslotted sounds for the mod, taken from the DS Sonic games (and also other games)
freeslot("sfx_elim01", "sfx_elim02", "sfx_elim03", "sfx_elim04",
		"sfx_elim07", "sfx_elim08", "sfx_elim09", "sfx_elim10")
		
// And freeslots for the announcer!
freeslot("sfx_elima1", "sfx_elima2", "sfx_elima3", "sfx_elima4", "sfx_elima5")

// 
// VBDDABLES
// these shouldn't be touched by the player at all so they're in a separate section
//

// Mod Info
bdd.version = "1.3"

// Derby
bdd.starting = true // Are we in the starting phase (POSITION!!, pregame)?
bdd.breaktime = false // Used for when the timer's refilling.

// Players
bdd.numplayers = 0 // How many players are participating?
bdd.numplayersremaining = 0 // How many players are remaining?
bdd.lastdied = "" // Who last died? (used for drawing messages)
bdd.didsomeoneragequit = false // lmao
bdd.didsomeoneleave = false // For when someone leaves during a netgame.

// Timing
bdd.oldscaletoggle = 0 // Is scaled time on?
bdd.olddetonationtime = 0 // Previous detonation time.
bdd.timer = 10 // How long until people get eliminated?
/* HAYA: These are local to the hud now.
bdd.curtime = "0" // String to display the time left.
bdd.realtime = "0" // String to display the real time of the session.
*/
bdd.gametimer = 0 // Used with curtime. Tracks the real time of the game.
bdd.breaktimer = 0 // Tracks the current time spent in break time.
bdd.currealpregame = 0 // Real pregame time. The other one's for tics now
bdd.grace = TICRATE // What's the minimum pause until the next detonation?
// bdd.kaboomtime = 0 // If I'll be honest I dunno what to call this one, but it's when the timer starts
// bdd.awardtime = 0 // yea
bdd.award = false // Don't know what to call this one for now. All I know is that I need this here to patch this bug
bdd.refilltics = (bdd.timer * TICRATE) / 7 // This simulates the whole refill mechanic of the timer.
bdd.bonustimer = 0 // Used for the time bonus popup.

// Overtime
bdd.overtime = false // Used to check if the game is in overtime or not.
bdd.oldovertime = false // Only enable this if overtime is going this race!
bdd.overtimer = 5 // Hidden timer during overtime. Counts down.
bdd.lastpassed = 0 // Used to track when someone swapped places in last.
bdd.oldlastpassed = 0

// Finishing
bdd.gameover = false
bdd.gameoverresults = false
bdd.gameovertime = 0 -- welcome back old friend

// Misc.
bdd.warningspeedup = 0
bdd.duelmode = false
bdd.doilus = -1
bdd.oldringscale = 0 -- For scaled ring payouts - allows you to toggle it on or off
bdd.oldjackpot = 0

// HUD General
bdd.maintimercolor = SKINCOLOR_ARTICHOKE
bdd.mainlettercolor = SKINCOLOR_WHITE
bdd.paniccolor = SKINCOLOR_LEMONADE
bdd.funnyvalue = 1 // Used for announcements
bdd.forfeitvalue = 1 // Used for forfeiting players
bdd.waitvalue = 1 // Used for free play
bdd.deathmessagetimer = 0 // Used for announcements
bdd.playerCam = nil -- used for end camera, do not touch!
--bdd.tally = {} -- handled further in derbyTally.lua

//
// TIMER HUD TABLES
// REGULAR GAMEPLAY
// 
// Regular bomb animation
bdd.hudbomb = {
	"BDD_BMB1",
	"BDD_BMB2"
}
// Red bomb
bdd.hudpanicbomb = {
	"BDD_BMB3",
	"BDD_BMB4"
}
// Overtime bomb
bdd.hudovertimebomb = {
	"BDD_BMB5",
	"BDD_BMB6",
}
// Red overtime bomb
bdd.hudovertimebombflash = {
	"BDD_BMB7",
	"BDD_BMB8"
}
// Overtime banners
bdd.hudovertimetext = {
	"BDD_OVT2",
	"BDD_OVT1"
}
// 2P bomb, for splitscreen
bdd.hudbomb2p = {
	"BD2_BMB0",
	"BD2_BMB1"
}

//
// TIMER HUD TABLES
// DUEL MODE
// 
// Regular duel bomb animation
bdd.duelhudbomb = {
	"BDD_BM21",
	"BDD_BM22"
}
// Flashing duel bomb
bdd.duelhudpanicbomb = {
	"BDD_BM23",
	"BDD_BM24"
}
// Overtime duel bomb
bdd.duelhudovertimebomb = {
	"BDD_BM25",
	"BDD_BM26",
}
// Flashing overtime duel bomb
bdd.duelhudovertimebombflash = {
	"BDD_BM27",
	"BDD_BM28"
}
// 2P duel bomb, for splitscreen
bdd.duelhudbomb2p = {
	"BD2_BM20",
	"BD2_BM21"
}

//
// WARNING HUD TABLES
//
bdd.warningpatchtop = {	// used for warning top hud, transitions between 5 patches, 
	"BDD_CRT1",
	"BDD_CRT2",
	"BDD_CRT3",
	"BDD_CRT4",
	"BDD_CRT5"
}
bdd.warningpatchbottom = {	// used for warning bottom hud, transitions between 5 patches, 
	"BDD_CRB1",
	"BDD_CRB2",
	"BDD_CRB3",
	"BDD_CRB4",
	"BDD_CRB5"
}
bdd.warningpatchmid = {	// used for warning bottom middle hud, transitions between 5 patches, 
	"BDD_BAS1",
	"BDD_BAS2",
	"BDD_BAS3",
	"BDD_BAS4",
	"BDD_BAS5"
}
bdd.warningpatchtext = {// used for warning text, alternates between 2 patches
	"BDD_TXM1",
	"BDD_TXM2"
}
bdd.warning4ptop = "BDD_SCR0"
bdd.warning4pbottom = "BDD_SCR1"
bdd.warning4pmid = "BDD_STB0"
bdd.warning4ptext = { "BDD_STX0", "BDD_STX1" }

// OUT!!!
// Appears when someone's eliminated
bdd.out1p = {
	"BDD_OUT1",
	"BDD_OUT2",
}
bdd.out2p = {
	"BD2_OUT1",
	"BD2_OUT2",
}
bdd.out4p = {
	"BD4_OUT1",
	"BD4_OUT2",
}

//bdd.transparancyas = { // unused -to detect if the hud uses subtractive or addative transparancy for warning hud
//	V_ADD,
//	V_REVERSESUBTRACT | V_60TRANS
//}

//
// HOST CVARS
// Only for the host! These impact the game itself.
//

// Pre-Game Time
// How long will the pre-game last?
bdd.pregametime = CV_RegisterVar({
	name = "bdd_pregametime",
	defaultvalue = "30",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = {MIN = 15, MAX = 90},
	func = function (cvar)
		print("Pregame time has been changed to " .. tostring(cvar.value) .. " starting the next match.")
	end,
	description = "How long will the pre-game last until the detonation begins?"
})

// Scaled Time
// Does time scale with the # of players?
bdd.scaledtimetoggle = CV_RegisterVar({
	name = "bdd_scaledtimetoggle",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function (cvar)
		S_StartSound(nil, sfx_elim04)
		print("Scaled detonation time has been toggled " .. (cvar.value and "\131on" or "\133off") .. "\128 starting the next match.")
	end,
	description = "Scales detonation time with the number of players in the lobby."
})

// Detonation Time
// How long will the pre-game last?
bdd.detonationtime = CV_RegisterVar({
	name = "bdd_detonationtime",
	defaultvalue = "30",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = {MIN = 5, MAX = 60},
	func = function (cvar)
		print("Detonation time has been changed to " .. tostring(cvar.value) .. " starting the next match.")
	end,
	description = "If scaled time is off, then this value is used for the detonation time."
})

// Ring Toggle
// Do you like classic Elimination, or do you want a more modern spin?
bdd.ringtoggle = CV_RegisterVar({
	name = "bdd_ringtoggle",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function (cvar)
		S_StartSound(nil, sfx_elim04)
		print("Ring payout has been toggled " .. (cvar.value and "\131on" or "\133off") .. "\128 starting the next match.")
	end,
	description = "Toggles the ring catch up mechanic. Awards rings to players falling behind."
})

// Scaled ring payout toggle
// see the description
bdd.scaledringtoggle = CV_RegisterVar({
	name = "bdd_scaledringtoggle",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function (cvar)
		S_StartSound(nil, sfx_elim04)
		print("Scaled rings has been toggled " .. (cvar.value and "\131on" or "\133off") .. "\128 starting the next match.")
	end,
	description = "Whether the ring payout from passed rounds is scaled per player or not."
})

// Jackpot Value
// see the description
bdd.jackpotvalue = CV_RegisterVar({
	name = "bdd_jackpotvalue",
	defaultvalue = "100",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = {MIN = 10, MAX = 999},
	func = function (cvar)
		print("Jackpot catchup value has been changed to " .. tostring(cvar.value) .. " starting the next match.")
		if cvar.value == 999 then print("By the way, I'm Fun.") end
	end,
	description = "How many rings will be awarded for catch-up?"
})

//
//	OVERTIME
//

// Overtime Toggle
// see the description
bdd.overtimetoggle = CV_RegisterVar({
	name = "bdd_overtimetoggle",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function (cvar)
		S_StartSound(nil, sfx_elim04)
		print("Derby overtime has been toggled " .. (cvar.value and "\131on" or "\133off") .. "\128 starting the next match.")
	end,
	description = "Enables overtime. If someone swaps places last minute, this kicks in!"
})

// Last Passed Limit
// Leniancy on overtime's activation.
bdd.lastpassedlimit = CV_RegisterVar({
	name = "bdd_lastpassedlimit",
	defaultvalue = "2",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = {MIN = 1, MAX = 10},
	func = function (cvar)
		print("The overtime activation limit has been changed to " .. tostring(cvar.value) .. " starting the next match.")
	end,
	description = "How lenient is overtime's activation (in seconds)?"
})

// Overtime limit
// The time limit on overtime and when it ends.
bdd.overtimelimit = CV_RegisterVar({
	name = "bdd_overtimelimit",
	defaultvalue = "5",
	flags = CV_NETVAR|CV_NOINIT|CV_CALL,
	possiblevalue = {MIN = 1, MAX = 30},
	func = function (cvar)
		print("The overtime time limit has been changed to " .. tostring(cvar.value) .. " starting the next match.")
	end,
	description = "How long does overtime last (in seconds)?"
})

//
// USER CVARS
// For the user! They can toggle settings they prefer.
//

// Debug logger
// aqua gets fucking tired of tracking shit so he's setting up a logger
bdd.debuglogger = CV_RegisterVar({
	name = "bdd_debuglogger",
	defaultvalue = "Off",
	flags = CV_NOINIT|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function (cvar)
		print("The BDD debug logger has been turned " .. (cvar.value and "\131on" or "\133off") .. "\128.")
	end,
	description = "For reporting bugs. Allows specific values to be reported to the console."
})

// User - Character Death Sounds
// Local toggle for if the player wishes to hear people FUCKING DYING across the map
bdd.userchardeath = CV_RegisterVar({
	name = "bdd_deathsounds",
	defaultvalue = "On",
	flags = 0,
	possiblevalue = CV_OnOff,
	func = 0,
	description = "Toggle for if you wish to hear character loss sounds when they're exploded."
})

// SETPREGAMETIME
// Control how long the pre-game lasts via the console
COM_AddCommand("bdd_preset", function(p, input)
	// We (and by that i mean me) gotta make sure it can tell what's a string and what isn't.
	local preset = string.lower(tostring(input))
	
	if preset == "frantic" or preset == "default" or preset == "relaxed" or preset == "funny" then
		S_StartSound(nil, sfx_elim04)
		CV_StealthSet(CV_FindVar("bdd_ringtoggle"), 1)
		CV_StealthSet(CV_FindVar("bdd_scaledtimetoggle"), 1)
		CV_StealthSet(CV_FindVar("bdd_detonationtime"), 30)
		
		// Frantic
		if preset == "frantic" then
			CV_StealthSet(CV_FindVar("bdd_jackpotvalue"), 200)
			CV_StealthSet(CV_FindVar("bdd_pregametime"), 15)
		// Default
		elseif preset == "default" then
			CV_StealthSet(CV_FindVar("bdd_jackpotvalue"), 100)
			CV_StealthSet(CV_FindVar("bdd_pregametime"), 30)
		// Relaxed
		elseif preset == "relaxed" then
			CV_StealthSet(CV_FindVar("bdd_jackpotvalue"), 50)
			CV_StealthSet(CV_FindVar("bdd_pregametime"), 90)
		// Funny
		elseif preset == "funny" then
			CV_StealthSet(CV_FindVar("bdd_jackpotvalue"), 999)
			CV_StealthSet(CV_FindVar("bdd_pregametime"), 15)
			CV_StealthSet(CV_FindVar("bdd_scaledtimetoggle"), 0)
			CV_StealthSet(CV_FindVar("bdd_detonationtime"), 5)
		end
		
		local output = ""
		
		if preset == "frantic" then output = "\133frantic\128" 
		elseif preset == "default" then output = "the defaults"
		elseif preset == "relaxed" then output = "\131relaxed\128" 
		elseif preset == "funny" then output = "\129f\130u\131n\132n\133y\128" end
		
		print("The preset has been changed to " .. output .. " starting the next match.")
		if preset == "funny" then print("I'm Fun!") end
	else
		print("bdd_preset: valid presets are \"frantic\", \"default\", \"relaxed\" and \"funny\".")
	end
end, COM_ADMIN)

// 
// MUSIC STUFF
// Exclusive to HEP3 or 2.4+
//
if Music_AddTune then
	Music_AddTune("bddintermission", 39, TN_VAPES)
end

//
// NETVARS
// To help prevent desynchs from occurring, the entire table will be NetVar'd.
// Thanks to Juggy again for helping shine a light on this lol
//
// please only rawset the stuff that's *actually* necessary this time
//

addHook("NetVars", function(net)
	// Derby
	bdd.starting = net($)
	bdd.breaktime = net($)

	// Players
	bdd.numplayers = net($)
	bdd.numplayersremaining = net($)
	bdd.lastdied = net($)
	bdd.didsomeoneragequit = net($)
	bdd.didsomeoneleave = net($)

	// Timing
	bdd.oldscaletoggle = net($)
	bdd.olddetonationtime = net($)
	bdd.timer = net($)
	bdd.gametimer = net($)
	bdd.breaktimer = net($)
	bdd.currealpregame = net($)
	bdd.award = net($)
	bdd.refilltics = net($)
	bdd.bonustimer = net($)

	// Overtime
	bdd.overtime = net($)
	bdd.oldovertime = net($)
	bdd.overtimer = net($)
	bdd.lastpassed = net($)
	bdd.oldlastpassed = net($)

	// Finishing
	bdd.gameover = net($)
	bdd.gameoverresults = net($)
	bdd.gameovertime = net($)
	
	// Misc.
	bdd.warningspeedup = net($)
	bdd.duelmode = net($)
	bdd.doilus = net($)
	bdd.oldringscale = net($)
	bdd.oldjackpot = net($)

	// HUD General
	bdd.funnyvalue = net($) // Used for announcements
	bdd.forfeitvalue = net($) // Used for forfeiting players
	bdd.waitvalue = net($) // Used for free play
	bdd.deathmessagetimer = net($) // Used for announcements
end)
